Make the Xonotic maps no longer exempt of the sRGB requirement, now that all fulfill...
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
1 #!/bin/sh
2
3 set -e
4
5 bspdir="$PWD/data"
6 url_http=http://beta.xonotic.org/autobuild-bsp/
7 url_ssh=xonotic-beta:autobuild-bsp/
8 build_cachedir="$HOME/xonotic-map-compiler.cache/"
9 screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
10 build_override="-bsp_timeout 3600 -vis_timeout 10800 -light_timeout 18000 -minimap_timeout 900 -scale_timeout 900 -timeout_stealing 0.8"
11 screenshot_override="9 900 5 +g_ctf 1"
12
13 getthemap_fail=false
14
15 allmaps()
16 {
17         commithash=$1
18         shift
19         for F in `git show "${commithash}:maps/"`; do
20                 case "$F" in
21                         *.map.options)
22                                 ;;
23                         *)
24                                 continue
25                                 ;;
26                 esac
27                 M=${F%.map.options}
28                 blobhash=`git rev-parse --revs-only "${commithash}:maps/$M.map.options" || true`-`git rev-parse --revs-only "${commithash}:maps/$M.map" || true`
29                 case "$blobhash" in
30                         -*)
31                                 ;;
32                         *-)
33                                 ;;
34                         *)
35                                 "$@" "$M" "$blobhash" "$commithash"
36                                 ;;
37                 esac
38         done
39 }
40
41 pre2spam()
42 {
43         map=$1
44         url=$2
45         branch=$3
46         hash=$4
47
48         branch=${branch##refs/heads/}
49         branch=${branch##refs/remotes/}
50         branch=${branch##origin/}
51         hash=`echo "$hash" | cut -c 1-7`
52
53         echo "[$branch $hash] starting map compile of $map"
54 }
55
56 ss2spam()
57 {
58         map=$1
59         url=$2
60         branch=$3
61         hash=$4
62         status=$5
63
64         branch=${branch##refs/heads/}
65         branch=${branch##refs/remotes/}
66         branch=${branch##origin/}
67         hash=`echo "$hash" | cut -c 1-7`
68
69         s_error=
70
71         if [ "$status" -ne 0 ]; then
72                 s_error="exited with status $status"
73         fi
74
75         if [ -n "$s_error" ]; then
76                 echo "[$branch $hash] \ 34screenshots of $map could not be made: $s_error"
77         else
78                 echo "[$branch $hash] screenshots of $map are available on $url"
79         fi
80 }
81
82 log2spam()
83 {
84         map=$1
85         url=$2
86         branch=$3
87         hash=$4
88         status=$5
89         time=$6
90
91         hash=`echo "$hash" | cut -c 1-7`
92
93         branch=${branch##refs/heads/}
94         branch=${branch##refs/remotes/}
95         branch=${branch##origin/}
96
97         s_samplesize=
98         s_failshaders=
99         s_leaked=
100         s_error=
101
102         if [ "$status" -ne 0 ]; then
103                 s_error="exited with status $status"
104         fi
105         while IFS= read -r L; do
106                 case "$L" in
107                         WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
108                                 s=${L##* }
109                                 if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
110                                         s_samplesize=$s
111                                 fi
112                                 ;;
113                         WARNING:\ Couldn\'t\ find\ image\ for\ shader\ textures/NULL)
114                                 # radiant stupid
115                                 ;;
116                         WARNING:\ Couldn\'t\ find\ image\ for\ shader\ *)
117                                 s_failshaders="$s_failshaders ${L##* }"
118                                 ;;
119                         ERROR:\ *)
120                                 if [ -z "$s_error" ]; then
121                                         s_error=$L
122                                 fi
123                                 ;;
124                         '******* leaked *******')
125                                 s_leaked=1
126                                 ;;
127                         '************ ERROR ************')
128                                 IFS= read -r s_error
129                                 ;;
130                 esac
131         done
132         s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
133         s_failshaders=${s_failshaders# }
134         if [ -n "$s_error" ]; then
135                 echo -n "[$branch $hash] \ 34failed"
136         else
137                 echo -n "[$branch $hash] finished"
138         fi
139         echo -n " map compile of $map ($url): $time sec"
140         if [ -n "$s_samplesize" ]; then
141                 echo -n ", FIX samplesize >= $s_samplesize"
142         fi
143         if [ -n "$s_failshaders" ]; then
144                 if [ -n "`echo "$s_failshaders" | cut -d ' ' -f 4-`" ]; then
145                         s_failshaders="`echo "$s_failshaders" | cut -d ' ' -f 1-3`..."
146                 fi
147                 echo -n ", FIX shaders $s_failshaders"
148         fi
149         if [ -n "$s_leaked" ]; then
150                 echo -n ", FIX LEAK"
151         fi
152         if [ -n "$s_error" ]; then
153                 s_error=`echo "$s_error" | sed "s,$PWD/\?,,g"`
154                 echo -n ", ERROR: $s_error"
155         fi
156         echo
157 }
158
159 buildthemap()
160 {
161         REFNAME=$1
162         url=$2
163         M=$3
164         blobhash=$4
165         commithash=$5
166         if lwp-request -m HEAD "$url$M-$blobhash.pk3"; then
167                 continue
168         fi
169
170         git reset --hard
171         git clean -xfd
172         git checkout -f "$commithash"
173
174         if [ -n "$IRCSPAM" ]; then
175                 pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM || true
176         fi
177
178         t0=`date +%s`
179
180         # It's sad that we must enforce this rule by code.
181         if grep -- '-nosRGB' "maps/$M.map.options" >/dev/null; then
182                 is_nosrgb=true
183         else
184                 is_nosrgb=false
185         fi
186         allow_build=true
187         if $is_nosrgb; then
188                 case "$REFNAME" in
189                         master|refs/heads/master|origin/master|refs/remotes/origin/master)
190                                 if [ -n "$IRCSPAM" ]; then
191                                         echo "\ 34ERROR: map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
192                                 fi
193                                 allow_build=false
194                                 ;;
195                         *)
196                                 if [ -n "$IRCSPAM" ]; then
197                                         echo "\ 34WARNING:\ f map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
198                                 fi
199                                 ;;
200                 esac
201         fi
202
203         set +e
204         $allow_build && (
205                 cd ../..
206                 misc/tools/xonotic-map-compiler-optionsfile "data/xonotic-maps.pk3dir/maps/$M" $build_override > "data/xonotic-maps.pk3dir/maps/$M.log" 2>&1
207         )
208         status=$?
209         set -e
210         if ! [ -f "maps/$M.bsp" ]; then
211                 echo >>"maps/$M.log" "ERROR: No BSP file"
212         fi
213         t1=`date +%s`
214         dt=$(($t1 - $t0))
215         if [ -n "$IRCSPAM" ]; then
216                 cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$status" "$dt" > "maps/$M.irc"
217         fi
218         zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
219         ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
220         cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
221         zip -9r "$M-full-$blobhash.pk3" `git diff --name-only --diff-filter=ACMRTUXB master...HEAD` || true
222         ln -snf "../$M-full-$blobhash.pk3" "$M-full.pk3" # from ALL branches, so beware!
223         rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
224         rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
225         if [ -n "$IRCSPAM" ]; then
226                 $IRCSPAM < "maps/$M.irc" || true
227         fi
228         if [ -n "$BUILD_ONE" ]; then
229                 exit
230         fi
231 }
232
233 screenshotthemap()
234 {
235         REFNAME=$1
236         url=$2
237         M=$3
238         blobhash=$4
239         commithash=$5
240         if lwp-request -m HEAD "$url$M-$blobhash/$M-000000.jpg"; then
241                 continue
242         fi
243
244         if ! unzip -l "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp"; then
245                 # no BSP file
246                 continue
247         fi
248
249         rm -rf ~/.xonotic/data
250         mkdir -p ~/.xonotic/data
251         (
252                 cd ../..
253                 if [ -n "$DISPLAY" ]; then
254                         misc/tools/xonotic-map-screenshot "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\""
255                 else
256                         case "$DRIVER" in
257                                 gl)
258                                         startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- :8
259                                         ;;
260                                 soft|*)
261                                         startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"vid_soft 1" $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
262                                         ;;
263                         esac
264                 fi
265         ) 2>&1 | tee ~/.xonotic/data/autoscreenshot.log
266         good=false
267         if mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
268                 ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
269         else
270                 mkdir "$M-$blobhash"
271                 ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
272         fi
273         mv ~/.xonotic/data/"$M.ircss" "$M-$blobhash"/
274         mv ~/.xonotic/data/autoscreenshot.log "$M-$blobhash"/
275         chmod 1777 "$M-$blobhash"
276         ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
277         rsync -vaSHP "$M-$blobhash" "$url_ssh"
278         rsync -vaSHP "$M" "$url_ssh""latest/"
279         if [ -n "$IRCSPAM" ]; then
280                 # It takes about 5 minutes for the server to update.
281                 sleep 360  # Cut it one more minute of slack.
282
283                 $IRCSPAM < "$M-$blobhash/$M.ircss" || true
284         fi
285         if [ -n "$BUILD_ONE" ]; then
286                 exit
287         fi
288 }
289
290 getthemap()
291 {
292         url=$1
293         bspdir_old=$2
294         bspdir=$3
295         M=$4
296         blobhash=$5
297         commithash=$6
298         if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
299                 if unzip -l "$bspdir/$M-$blobhash.pk3" >/dev/null 2>&1; then
300                         return 0
301                 fi
302         fi
303         if ! wget -c -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
304                 if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
305                         rm -f "$bspdir/$M-$blobhash.pk3"
306                         echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
307                         getthemap_fail=true
308                         return 0
309                 fi
310         fi
311         if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
312                 rm -f "$bspdir/$M-$blobhash.pk3"
313                 echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
314                 getthemap_fail=true
315                 return 0
316         fi
317 }
318
319 indexthemap()
320 {
321         REFNAME=$1
322         M=$2
323         blobhash=$3
324         commithash=$4
325         echo "$M $blobhash $commithash $REFNAME"
326 }
327
328 rundownload()
329 {
330         mkdir -p "$bspdir" "$bspdir.old"
331         for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
332                 if [ -e "$b" ]; then
333                         mv "$b" "$bspdir.old"/
334                 fi
335         done
336         allmaps "HEAD" getthemap "$url_http" "$bspdir.old" "$bspdir"
337 }
338
339 branches()
340 {
341         git for-each-ref 'refs/remotes' | grep -vE '    refs/remotes/([^/]*/HEAD|.*/archived/.*)$'
342 }
343
344 runmakeindex()
345 {
346         cd data/xonotic-maps.pk3dir
347         branches | while read -r HASH TYPE REFNAME; do
348                 allmaps "$HASH" indexthemap "$REFNAME"
349         done
350         cd ../..
351 }
352
353 case "$1" in
354         build)
355                 cd data/xonotic-maps.pk3dir
356                 branches | while read -r HASH TYPE REFNAME; do
357                         if [ -f "$build_cachedir/$HASH" ]; then
358                                 continue
359                         fi
360                         allmaps "$HASH" buildthemap "$REFNAME" "$url_http"
361                         touch "$build_cachedir/$HASH"
362                 done
363                 git checkout -f master
364                 ;;
365         screenshot)
366                 runmakeindex > "branches.idx.new"
367                 rsync -vaSHP "branches.idx.new" "$url_ssh""branches.idx.new"
368                 rm -f "branches.idx.new"
369                 cd data/xonotic-maps.pk3dir
370                 branches | while read -r HASH TYPE REFNAME; do
371                         if [ -f "$screenshot_cachedir/$HASH" ]; then
372                                 continue
373                         fi
374
375                         git reset --hard
376                         git clean -xfd
377                         git checkout -f "$HASH"
378
379                         rundownload
380                         if $getthemap_fail; then
381                                 continue
382                         fi
383
384                         allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
385
386                         touch "$screenshot_cachedir/$HASH"
387                 done
388                 git checkout -f master
389                 ;;
390         makeindex)
391                 runmakeindex
392                 ;;
393         download)
394                 if ! which unzip >/dev/null 2>&1; then
395                         echo "Cannot find unzip, bailing out"
396                         exit 1
397                 fi
398                 if ! cd data/xonotic-maps.pk3dir >/dev/null 2>&1; then
399                         echo "data/xonotic-maps.pk3dir does not exist, not downloading"
400                         exit 0
401                 fi
402                 rundownload
403                 cd ../..
404                 echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
405                 ls -l "$bspdir.old" || true
406                 ;;
407         download-latest)
408                 mkdir -p "$bspdir"
409                 cd "$bspdir"
410                 rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
411                 wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url_http""latest"
412                 ;;
413         log2spam-test)
414                 log2spam "mapname" "http://mapurl" "branch" "commit" "0"
415                 ;;
416 esac